Attribute VB_Name = "ModMain"
Public ObjTapi As TAPI
Public ObjAddress As ITAddress
Public ObjAddressCap As ITAddressCapabilities
Public ObjCollection As ITCollection
Public ObjCallControl As ITBasicCallControl
Public ObjCallControl2 As ITBasicCallControl2
Public ObjCallInfo As ITCallInfo
Public ObjCallState As ITCallStateEvent
Public ObjCallNotifi As ITCallNotificationEvent
Public ObjDigitEvent As ITDigitDetectionEvent
Public ObjFaileTerminal As ITFileTerminalEvent
Public ObjLegacy As ITLegacyCallMediaControl
Public ObjMediaControl As ITMediaControl
Public ObjMediaPlayBack As ITMediaPlayback
Public ObjMediaRecord As ITMediaRecord
Public ObjMediaSupport As ITMediaSupport
Public ObjTerminalSupport As ITTerminalSupport
Public ObjTerminal As ITTerminal
Public LngTokenReg As Long
Public LngCallBack As Long

Public Const All_Events = TE_CALLMEDIA Or TE_CALLNOTIFICATION Or TE_CALLSTATE Or TE_DIGITEVENT
Public Const Media_Type = TAPIMEDIATYPE_AUDIO

                            
Public Const CalmathVersion = "Autumn 2001 build 920"
Public Const ISO_8601 = 1
Public Const Gregorian = ISO_8601
Public Const Julian = 2
Public Const Hebrew = 3
Public Const Islamic = 4
Public Const Persian = 98

Public Const weekStartsOnMonday = ISO_8601
Public Const weekStartsOnSunday = 2
Public Const weekStartsOnSaturday = 3
Public Const weekStartsOnFriday = 4
Public Const weekStartsOnThursday = 5
Public Const weekStartsOnWednesday = 6
Public Const weekStartsOnTuesday = 7

Public Const Jan1InWeek1 = 0
Public Const Jan4InWeek1 = ISO_8601
Public Const Jan7InWeek1 = 2

Public Const English = 1
Public Const Arabic = Islamic

Public Const Dutch = 31
Public Const French = 33
Public Const German = 49
Public Const Farsi = Persian

Public Const Signed = -1
Public Const UnSigned = 1
'**************************************************************
Public Const Title = " "
Public Const Msg_100 = "        ..."
Public Const Msg_101 = "       "
'**************************************************************
Public User As String
Public Usr_Name As String
Public Usr_Family As String
Public Permission As Integer
Public Login_Time As String

Public Today_Date As String
Public Ring_Count As Integer
Public No_Answer As Boolean
Public Save_Call As Boolean
Public SysTry As Boolean
Public App_Path As String


Sub civil_persian(ByRef iYear As Integer, _
                 ByRef iMonth As Integer, _
                 ByRef iDay As Integer)
    Call jdn_persian(civil_jdn(iYear, _
                              iMonth, _
                              iDay), _
                    iYear, iMonth, iDay)
End Sub


Private Function Ceil(Number As Single) As Long
    Ceil = -Sgn(Number) * Int(-Abs(Number))

End Function

Private Function leap_persian(iYear As Integer) As Boolean
    If iYear > 0 Then
        leap_persian = ((((((iYear - (474)) Mod 2820) + 474) + 38) * 682) Mod 2816) < 682
    Else
        leap_persian = ((((((iYear - (473)) Mod 2820) + 474) + 38) * 682) Mod 2816) < 682
    End If
End Function
Function persian_jdn(iYear As Integer, _
                     iMonth As Integer, _
                     iDay As Integer) As Long
    Const PERSIAN_EPOCH = 1948321
    Dim epbase As Long
    Dim epyear As Long
    Dim mdays As Long
    If iYear >= 0 Then
        epbase = iYear - 474
    Else
        epbase = iYear - 473
    End If
    epyear = 474 + (epbase Mod 2820)
    If iMonth <= 7 Then
        mdays = (CLng(iMonth) - 1) * 31
    Else
        mdays = (CLng(iMonth) - 1) * 30 + 6
    End If
    persian_jdn = CLng(iDay) _
            + mdays _
            + Fix(((epyear * 682) - 110) / 2816) _
            + (epyear - 1) * 365 _
            + Fix(epbase / 2820) * 1029983 _
            + (PERSIAN_EPOCH - 1)
End Function

Sub jdn_persian(jdn As Long, _
                ByRef iYear As Integer, _
                ByRef iMonth As Integer, _
                ByRef iDay As Integer)
    Dim depoch
    Dim cycle
    Dim cyear
    Dim ycycle
    Dim aux1, aux2
    Dim yday
    depoch = jdn - persian_jdn(475, 1, 1)
    cycle = Fix(depoch / 1029983)
    cyear = depoch Mod 1029983
    If cyear = 1029982 Then
        ycycle = 2820
    Else
        aux1 = Fix(cyear / 366)
        aux2 = cyear Mod 366
        ycycle = Int(((2134 * aux1) + (2816 * aux2) + 2815) / 1028522) + aux1 + 1
    End If
    iYear = ycycle + (2820 * cycle) + 474
    If iYear <= 0 Then
        iYear = iYear - 1
    End If
    yday = (jdn - persian_jdn(iYear, 1, 1)) + 1
    If yday <= 186 Then
        iMonth = Ceil(yday / 31)
    Else
        iMonth = Ceil((yday - 6) / 30)
    End If
    iDay = (jdn - persian_jdn(iYear, iMonth, 1)) + 1
End Sub
Function persian_MonthName(iMonth As Integer) As String
    Select Case iMonth
    Case 1
        persian_MonthName = ""
    Case 2
        persian_MonthName = ""
    Case 3
        persian_MonthName = ""
    Case 4
        persian_MonthName = ""
    Case 5
        persian_MonthName = ""
    Case 6
        persian_MonthName = ""
    Case 7
        persian_MonthName = ""
    Case 8
        persian_MonthName = ""
    Case 9
        persian_MonthName = ""
    Case 10
        persian_MonthName = ""
    Case 11
        persian_MonthName = ""
    Case 12
        persian_MonthName = ""
    Case Else
        persian_MonthName = ""
    End Select
End Function

Sub jdn_civil(jdn As Long, _
              ByRef iYear As Integer, _
              ByRef iMonth As Integer, _
              ByRef iDay As Integer)

    Dim l As Long
    Dim k As Long
    Dim n As Long
    Dim i As Long
    Dim j As Long

    If (jdn > 2299160) Then
        l = jdn + 68569
        n = ((4 * l) \ 146097)
        l = l - ((146097 * n + 3) \ 4)
        i = ((4000 * (l + 1)) \ 1461001)
        l = l - ((1461 * i) \ 4) + 31
        j = ((80 * l) \ 2447)
        iDay = l - ((2447 * j) \ 80)
        l = (j \ 11)
        iMonth = j + 2 - 12 * l
        iYear = 100 * (n - 49) + i + l
    Else
        Call jdn_julian(jdn, iYear, iMonth, iDay)
    End If

End Sub

Sub civil_normDate(ByRef iYear As Integer, _
                   ByRef iMonth As Integer, _
                   ByRef iDay As Integer, _
                   Optional CalendarType As Integer = Gregorian)
    Dim monLength As Integer

    If (iMonth > 12) Then
        iYear = iYear + (iMonth \ 12)
        iMonth = iMonth Mod 12
    ElseIf (iMonth < 1) Then
        iYear = iYear + (iMonth \ 12) - 1
        iMonth = 12 + (iMonth Mod 12)
    End If

    monLength = civil_daysInMonth(iYear, iMonth, CalendarType)
    While (iDay > monLength)
        If (iMonth = 12) Then
            iMonth = 1
            iYear = iYear + 1
        Else
            iMonth = iMonth + 1
        End If
        iDay = iDay - monLength
        monLength = civil_daysInMonth(iYear, iMonth, CalendarType)
    Wend

    While (iDay < 1)
        If (iMonth = 1) Then
            iMonth = 12
            iYear = iYear - 1
        Else
            iMonth = iMonth - 1
        End If
        iDay = iDay + civil_daysInMonth(iYear, iMonth, CalendarType)
    Wend
End Sub
Function civil_monthName(iMonth As Integer, _
                         Optional Language As Integer = 1) As String
    Dim Jan As String
    Dim Feb As String
    Dim Mar As String
    Dim Apr As String
    Dim May As String
    Dim Jun As String
    Dim Jul As String
    Dim Aug As String
    Dim Sep As String
    Dim Oct As String
    Dim Nov As String
    Dim Dec As String
        
    Select Case Language
    Case Dutch
         Jan = "Januari"
         Feb = "Februari"
         Mar = "Maart"
         Apr = "April"
         May = "Mei"
         Jun = "Juni"
         Jul = "Juli"
         Aug = "Augustus"
         Sep = "September"
         Oct = "Oktober"
         Nov = "November"
         Dec = "December"
    Case French
         Jan = "Janvier"
         Feb = "Fvrier"
         Mar = "Mars"
         Apr = "Avril"
         May = "Mai"
         Jun = "Juin"
         Jul = "Juillet"
         Aug = "Aot"
         Sep = "Septembre"
         Oct = "Octobre"
         Nov = "Novembre"
         Dec = "Dcembre"
    Case German
         Jan = "Januar"
         Feb = "Februar"
         Mar = "Mrz"
         Apr = "April"
         May = "Mai"
         Jun = "Juni"
         Jul = "Juli"
         Aug = "August"
         Sep = "September"
         Oct = "Oktober"
         Nov = "November"
         Dec = "Dezember"
    Case Else
         Jan = "January"
         Feb = "February"
         Mar = "March"
         Apr = "April"
         May = "May"
         Jun = "June"
         Jul = "July"
         Aug = "August"
         Sep = "September"
         Oct = "October"
         Nov = "November"
         Dec = "December"
    End Select

    Select Case iMonth
    Case 1
        civil_monthName = Jan
    Case 2
        civil_monthName = Feb
    Case 3
        civil_monthName = Mar
    Case 4
        civil_monthName = Apr
    Case 5
        civil_monthName = May
    Case 6
        civil_monthName = Jun
    Case 7
        civil_monthName = Jul
    Case 8
        civil_monthName = Aug
    Case 9
        civil_monthName = Sep
    Case 10
        civil_monthName = Oct
    Case 11
        civil_monthName = Nov
    Case 12
        civil_monthName = Dec
    Case Else
        civil_monthName = "Error"
    End Select
End Function
Function civil_leapyear(iYear As Integer, _
                Optional CalendarType As Integer = Gregorian) _
         As Boolean

    If CalendarType <> Gregorian Or iYear < 1582 Then
    
        civil_leapyear = ((iYear Mod 4) = 0)
    Else
    
        civil_leapyear = ((iYear Mod 4) = 0) Xor _
                         ((iYear Mod 100) = 0) Xor _
                         ((iYear Mod 400) = 0)
    End If

End Function
Function civil_jdn(iYear As Integer, _
                   iMonth As Integer, _
                   iDay As Integer, _
                   Optional CalendarType As Integer = Gregorian) As Long
    Dim lYear As Long
    Dim lMonth As Long
    Dim lDay As Long

    If CalendarType = Gregorian And ((iYear > 1582) Or _
        ((iYear = 1582) And (iMonth > 10)) Or _
        ((iYear = 1582) And (iMonth = 10) And (iDay > 14))) _
    Then
        lYear = CLng(iYear)
        lMonth = CLng(iMonth)
        lDay = CLng(iDay)
        civil_jdn = ((1461 * (lYear + 4800 + ((lMonth - 14) \ 12))) \ 4) _
            + ((367 * (lMonth - 2 - 12 * (((lMonth - 14) \ 12)))) \ 12) _
            - ((3 * (((lYear + 4900 + ((lMonth - 14) \ 12)) \ 100))) \ 4) _
            + lDay - 32075
    Else
        civil_jdn = julian_jdn(iYear, iMonth, iDay)
    End If

End Function
Function civil_daysInMonth(iYear As Integer, _
                     iMonth As Integer, _
                     Optional CalendarType As Integer = Gregorian) As Integer
    Select Case iMonth
    Case 2
        If civil_leapyear(iYear, CalendarType) Then
            civil_daysInMonth = 29
        Else
            civil_daysInMonth = 28
        End If
    Case 4, 6, 9, 11
        civil_daysInMonth = 30
    Case Else
        civil_daysInMonth = 31
    End Select
End Function

Sub jdn_julian(jdn As Long, _
                       ByRef iYear As Integer, _
                       ByRef iMonth As Integer, _
                       ByRef iDay As Integer)
    Dim l As Long
    Dim k As Long
    Dim n As Long
    Dim i As Long
    Dim j As Long

    j = jdn + 1402
    k = ((j - 1) \ 1461)
    l = j - 1461 * k
    n = ((l - 1) \ 365) - (l \ 1461)
    i = l - 365 * n + 30
    j = ((80 * i) \ 2447)
    iDay = i - ((2447 * j) \ 80)
    i = (j \ 11)
    iMonth = j + 2 - 12 * i
    iYear = 4 * k + n + i - 4716

End Sub

Function julian_jdn(iYear As Integer, _
                    iMonth As Integer, _
                    iDay As Integer) As Long
    Dim lYear As Long
    Dim lMonth As Long
    Dim lDay As Long

    lYear = CLng(iYear)
    lMonth = CLng(iMonth)
    lDay = CLng(iDay)

    julian_jdn = 367 * lYear - _
            ((7 * (lYear + 5001 + ((lMonth - 9) \ 7))) \ 4) _
            + ((275 * lMonth) \ 9) + lDay + 1729777

End Function

Sub julian_normDate(ByRef iYear As Integer, _
                   ByRef iMonth As Integer, _
                   ByRef iDay As Integer)
    Call civil_normDate(iYear, iMonth, iDay, Julian)
End Sub

Function julian_monthName(iMonth As Integer) As String
    julian_monthName = civil_monthName(iMonth)
End Function



Public Function Persian_DayName(DayWeak As Integer) As String
Select Case DayWeak
    Case 1
        Persian_DayName = ""
    Case 2
        Persian_DayName = " "
    Case 3
        Persian_DayName = " "
    Case 4
        Persian_DayName = ""
    Case 5
        Persian_DayName = " "
    Case 6
        Persian_DayName = ""
    Case 7
        Persian_DayName = ""
End Select

End Function

Public Function Decode_Password(ByVal Password As String) As String
Dim LngLen As Long
Dim Temp_password As String
Dim Asc_Password() As Integer
LngLen = Len(Password)
ReDim Asc_Password(LngLen) As Integer
Temp_password = ""
For i = 1 To LngLen Step 4
    Asc_Password(i) = Asc(Mid(Password, i, 1))
    Temp_password = Temp_password & Chr(((Asc_Password(i) - 1) / 2))
Next i
Decode_Password = Temp_password
End Function

Public Function Encode_Password(ByVal Password As String) As String
Dim LngLen As Long
Dim Temp_password As String
Dim Asc_Password() As Integer
LngLen = Len(Password)
ReDim Asc_Password(LngLen) As Integer
Temp_password = ""
For i = 1 To LngLen
    Asc_Password(i) = Asc(Mid(Password, i, 1))
    Temp_password = Temp_password & Chr(((Asc_Password(i) * 2) + 1)) & Chr(Asc_Password(i) - 10) & i & Chr(((Asc_Password(i) - 10) * 2) + 1)
Next i
Encode_Password = Temp_password
End Function
